classdef mode_CW_trace
    methods (Static)
        function out = placement(hMG)
            out = 'right'; % TODO: return 'right' or 'left' to place your toolbox in one of the panels
            % TODO: If you would like your plugin to appear in only one specific mode,
            % check f.i. hMG.has_mode('2D') and return 'none'
            % if your supported mode (or supported something else such as
            % sample type, probe type, application or whatever) is not
            % present.
        end
    end
    
    properties
        baseline;
        show = false;
        coor = zeros(2,2);
        calculate_tau = false;
        differentials
        img = 0;
        lap = 10;
        dpdt_max = 0;
        dpdt_min = 0;
        dp_max = 0;
        qrs
        qrs_array
        structs
        rel1
        rel2
        count;
        tau = 0;
        tau2 = 0;
        high
        onethree
        original_dpdt
        smooth_factor = 15;
        smoothing_function = 'moving';
        show_smooth = false;  
        show_plot = false; 
        clr = 250;
        or_img = 0;
    end
    
    methods
        
        function this=mode_CW_trace(varargin)
            this.widgets.trace = gclab.widgets.button(this ...
                ,'name','Trace' ...     
                ,'ctrlargs', {'tooltip','Trace'} ...
                ,'CallBack',@(varargin)this.button_callback(varargin{:}) ... 
                );
            this.widgets.model = gclab.widgets.checkbox(this,'name','Plot traces' ...
                ,'CallBack',@(varargin)this.plot(varargin{:}) ...  
                ); 
            this.widgets.tau = gclab.widgets.checkbox(this,'name','Calculate Tau' ...
                ,'CallBack',@(varargin)this.calc_tau(varargin{:}) ...  
                ); 
            this.widgets.lap = gclab.widgets.slider(this,'name','            LAP' ...
                ,'bounds', [0 30] ...
                ,'step', [1/6 1/30] ...
                ,'value', 10 ...
                ,'integer', true ...
                ,'CallBack',@(varargin)this.lap_callback(varargin{:}) ... % TODO: Slider update callback. Should use one member function per callback for readability. Ommit this if you do not need a callback for the control.
                );
            this.widgets.manual = gclab.widgets.button(this,'name','Manual trace' ...
                ,'CallBack',@(varargin)this.use_manual(varargin{:}) ...  
                ); 
            
             this.widgets.show_image = gclab.widgets.checkbox(this,'name','Show image' ...
                ,'CallBack',@(varargin)this.show_img(varargin{:}) ...  
                ); 
           
        end
        
        function on_expand(this)
            select_me = true; % TODO: Choose whether or not my mouse handler shall be selected when toolbox is expanded in GUI
            this.window.toolbox('cine').add_mouse_handler(this,select_me);
            % (*)
        end
        
        function on_collapse(this)
            on_collapse@gclab.toolbox(this);
            this.window.toolbox('cine').remove_mouse_handler('example mouse handler'); % (*)
            
            % TODO: Add additional stuff here to e.g. free up memory
            % resources or delete temporaries when the toolbox is
            % deactivated by the user (i.e. collapsed in the GUI)
        end
         
        function smooth_callback(this,varargin)
            this.smooth_factor = get(this.widgets.smooth.ctrl,'Value');
        end
        
        function lap_callback(this,varargin)
            this.lap = get(this.widgets.lap.ctrl,'Value');
        end
        
        function plot(this,varargin)
            if this.show_plot == false
                this.show_plot = true;
            else
                this.show_plot = false;
            end
        end
        
        function calc_tau(this, varargin)
            if this.calculate_tau == false
                this.calculate_tau = true;
            else
                this.calculate_tau = false;
            end
        end
        
        function show_img(this, varargin)
            if this.show == false
                this.show = true;
            else
                this.show = false;
            end
        end
        
        function use_manual(this, varargin)
            if this.coor(1,1) == 0
                this.window.viewer.info('Pick two points');
            elseif this.coor(2,1) == 0
                this.window.viewer.info('Pick a 2nd point');
            elseif this.coor(2,1) ~= 0
                this.manual_tracing();
                this.coor = [0 0; 0 0];
            end
        end
        
        function button_callback(this,varargin)
            t1 = clock;
            dat = (struct2cell((load('plugins/constants.mat'))));
            dat = cell2mat(dat);
            this.rel1 = (dat(1));
            this.rel2 = (dat(2));
            this.count = (dat(3));
            disp(this.rel1);
            this.dpdt_max = zeros(1,1);
            this.dpdt_min = zeros(1,1);
            this.dp_max = 0;
            this.tau = 0;
            this.tau2 = 0;
            this.differentials = zeros(1,1);
            
            udth_cw = gcutil.udthandle(this.window,'CW');
            image = udth_cw.get_frames;
            [height width] = size(image);

            q = gcutil.udthandle(this.window).udtget('EcgQrsTrig');
    
            interval = gcutil.udthandle(this.window).udtget('DisplayInterval');
            this.qrs = zeros(1, length(q) + 2);
            this.qrs(1) = 1;
                
            for v = 2:length(q)+1
                this.qrs(v) = floor(width*(q(v-1) - interval(1))/(interval(2) - interval(1)));
            end
            this.qrs(length(q)+2) = width-1;
            this.qrs_array = zeros(1,length(this.qrs));
            this.structs = cell(1,20);
            this.high = 0;
            this.onethree = zeros(2,2);
            this.original_dpdt = 0;
            this.img = image;
            this.or_img = image;    
            this.baseline = 1;
            %Filter
            if this.show == true;            imtool(image);end;

            disp('--------------');
            disp('Filtering image..');
            this.filter_image();

            for i = 1:height
                for k = 1:width
                    if this.img(i,k) == 255
                        image(i,k) = 255;
                    end
                end
            end
%             if this.show == true;            imtool(image);end;
            
            for l = 1:length(this.qrs)-2
                half = this.qrs(l) + floor((this.qrs(l+1) - this.qrs(l))*0.85);
                for j = 1:height
                    this.img(j,half:(half+5)) = 0;
                end
            end
            %Trace
            this.trace();

            disp('--------------');
            disp('Results:');
            av = round(sum(this.original_dpdt(this.original_dpdt~=0),2)./sum(this.original_dpdt~=0,2));
            str = strcat('RPR dP/dt(in mmHg/s). Average: ', int2str(int32(av)));
            disp(str); 
            disp(this.original_dpdt(2:length(this.original_dpdt)));

            av = round(sum(this.dpdt_max(this.dpdt_max~=0),2)./sum(this.dpdt_max~=0,2));
            str = strcat('max dP/dt(in mmHg/s). Average: ', int2str(int32(av)));
            disp(str); 
            disp(this.dpdt_max(2:length(this.dpdt_max)));
            
            av = round(sum(this.dpdt_min(this.dpdt_min~=0),2)./sum(this.dpdt_min~=0,2));
            str = strcat('min dP/dt(in mmHg/s). Average: ', int2str(int32(av)));
            disp(str); 
            disp(this.dpdt_min(2:length(this.dpdt_min)));
            
            av = round(sum(this.dp_max(this.dp_max~=0),2)./sum(this.dp_max~=0,2));
            str = strcat('max dP(in mmHg). Average: ',int2str(int32(av)),' (',num2str(0.01*round(sqrt(0.25*av)*100)),' m/s)');
            disp(str); 
            disp(round(this.dp_max(2:length(this.dp_max))));
               
            if this.calculate_tau == true
                av = round(sum(this.tau(this.tau~=0),2)./sum(this.tau~=0,2));
                str = strcat('Relaxation constant (method 1). Average: ',int2str(int32(av)));
                disp(str); 
                disp(round(this.tau(2:length(this.tau))));
                
                av = round(sum(this.tau2(this.tau2~=0),2)./sum(this.tau2~=0,2));
                if int32(av) ~= 0
                    str = strcat('Relaxation constant (method 2). Average: ',int2str(int32(av)));
                    disp(str); 
                    disp(round(this.tau2(2:length(this.tau2))));
                end
            end
            
            disp('--------------');
            disp('Total time..');
            disp(etime(clock,t1));
            
            disp('--------------');
            
%               a = this.or_img(:,1:c); b = this.or_img(:,c+1:2*c);
%             new = [a; b];
                

            if this.show == true; imtool(this.or_img);end;
            data = [this.rel1 this.rel2 this.count];
            save('+plugins/constants.mat', 'data');
            disp('Done!');
        end

        %%% Filtrerer bildet, og returnerer et sort-hvitt bilde, som viser
        %%% kantene i bildet. 
        
        
        function filter_image(this)
            image = this.img;

            [height width] = size(image);
            bline = height*gcutil.udthandle(this.window,'CW').udtget('Baseline');
            this.baseline = bline;
            %%%start method 1

            test = 1:0.5/height:1.5;
            me = mean(mean(image(1:height,:))); 
            med = median(median(image(1:height,:))); 
            image(1:bline,:) = 0;
            if me > 6
                for m = 5:width-5
                    for k = 5:height-5
                        image(k,m) = image(k,m)*test(k);
                    end
                end
            end
            
            mid = round(bline+(height-bline)/4);
            
            imn = mean(image(height, :));
            image(1:mid, 1:width) = image(1:mid, 1:width)-med;
            image(mid+1:height, 1:width) = image(mid+1:height, 1:width)-imn/2;
           
            image = medfilt2(image, [10 10]);
%             imtool(image);
            image = imfilter(image, fspecial('gaussian', [10 1]));
%             imtool(image);
            image = medfilt2(image, [5 5]);
            
            for m = 1:width
                for k = 1:height
                    if image(k,m)/med > 1;
                        image(k,m) = 255;
                    else
                        image(k,m) = 0;
                    end
                end
            end
            
            for m = 2:width-1
                for k = 2:height-1
                    if image(k-1,m) ~= 0&&image(k-1,m-1)~= 0&&image(k-1,m+1)~= 0&&image(k,m-1)~= 0&&image(k,m+1)~= 0&&image(k+1,m-1)~= 0&&image(k+1,m)~= 0&&image(k+1,m+1) ~= 0 == 1
                        image(k,m) = 100;
                    end
                end
            end
            
            for m = 2:width-1
                for k = 2:height
                    if (1/3)*(image(k-1,m-1) + image(k-1,m) + image(k-1,m+1)) == 0
                        image(k,m) = 0;
                    elseif image(k,m) == 100
                        image(k,m) = 0;
                    end
                end
            end
            
            image(1:5,:) = 0; image(:,1:5) = 0;  image(:,(width-5):width) = 0;
            this.img = image;
        end    
        
        
        %%% Initialiserer hele tracing-prosessen, som bestr av  finne
        %%% hastighetskurvene og regne ut trykkgradientene.
        
        function trace(this)
            disp('Tracing stuctures..');
            this.extractStructures();
            disp('Calculating values..');
            this.calculate();
        end
        
        %%% Finner strukturene i det filtrerte bildet
        
        function extractStructures(this)
            [height width] = size(this.img);

            more_structures = true;
            pos = 2;
            while more_structures == true
                found = false;
                k = floor(height*0.6);
                for m = pos-1:width
                     if this.img(k,m) == 255
                         this.snake([k m]);
                         found = true;
                         pos = m;
                         break;
                     end
                end
                if found == false
                   more_structures = false;
                end
            end            
        end
        
        %%% Nr en kant er detektert vil denne metoden flge denne
        %%% strukturen helt til hele er funnet og ekstrahert.
        
        function snake(this, varargin)
            coord = cell2mat(varargin(1));

            %Declare variables
            [height width] = size(this.img);
            buffer = ones(2000,2); counter = 1; 
            buffer(counter,:) = [coord(1) coord(2)]; 
            nd = [1 1];
            this.img(coord(1),coord(2)) = 100; 
            highest = [coord(1) coord(2)];
            rightmost = [coord(1) coord(2)];
            leftmost = [coord(1) coord(2)];
            l = 1;
            
            %continue until entire structure is found
            for b = 1:2
                newchance = true;
                if b == 2
                    l = -1;
                end
                nd = counter+1;
                coord = cell2mat(varargin(1));
                struct_done = false;
                while struct_done == false
                    found = false; go = false;
                    for k = -l:l:l
                        for m = -l:l:l
                            if this.img(coord(1) + k, coord(2) + m) == 255
                                coord(1) = coord(1) + k; coord(2) = coord(2) + m;
                                counter = counter + 1;
                                this.img(coord(1),coord(2)) = 100;
                                buffer(counter, :) = [coord(1) coord(2)];                            
                               
                                if coord(2) >= rightmost(2)
                                    rightmost = [coord(1) coord(2)];
                                end
                                if coord(2) <= leftmost(2)
                                    leftmost = [coord(1) coord(2)];
                                end
                                if (coord(1)) > highest(1)
                                    highest = [coord(1) coord(2)];
                                end
                                
                                go = true;
                                found = true;
                                break;
                            end
                        end
                        if go == true;
                            break
                        end
                    end
                    if found == false
                        if newchance == false
                            struct_done = true;
                        end
                        if b == 2
                            dif = 1000; temp_diff = 1000;
                            for i = 1:height
                                for k = 1:3
                                    if this.img(i,coord(2)+k) == 255
                                        temp_diff = abs(i-coord(1));
                                        if temp_diff<dif
                                            dif=temp_diff;
                                            coord_temp = [i (coord(2)+1)];
                                        end
                                    end
                                end
                            end
                            if dif == 1000
                                newchance = false; 
                            else
                                coord = coord_temp;
                            end;
                        elseif b == 1
                            dif = 1000; temp_diff = 1000;
                            for i = 1:height
                                for k = 1:3
                                    if this.img(i,coord(2)-k) == 255
                                        temp_diff = abs(i-coord(1));
                                        if temp_diff<dif
                                            dif=temp_diff;
                                            coord_temp = [i (coord(2)-1)];
                                        end
                                    end
                                end
                            end
                            if dif == 1000
                                newchance = false; 
                            else
                                coord = coord_temp;
                            end;
                        end
                        
                    end
                end  
            end
            
            %Finner ut hvilken QRS-syklus denne blodstrmmen hrer til.
            for u = 1:length(this.qrs)
                if highest(2) < this.qrs(u)
                    now = u-1;
                    break;
                end
            end
            
            %Srger for  lagre den riktige strukturen. NOTE: Kan
            %forbedres?
            if highest(1) > this.qrs_array(now)
                this.qrs_array(now) = highest(1);
            else
                for i = 1:length(buffer(:,1))
                    if buffer(i,1) ~= 0
                        this.img(buffer(i,1), buffer(i,2)) = 255;
                        if buffer(i,:) == cell2mat(varargin(1))
                            this.img(buffer(i,1), buffer(i,2)) = 0;
                        end
                    end    
                end
                
                return;
            end
            
            this.high(now) = highest(2);
            
            buff = buffer;
            buff_t = flipud(buffer(nd:counter,:));
            buff(1:length(buff_t(:,1)),:) = buff_t;
            buff(length(buff_t(:,1))+1:counter,:) = buffer(1:(nd-1),:);
            buffer = buff;
            
            this.structs(now) = {buffer};
        end
        
        
        %%% Tar hver struktur som er funnet og gjr litt preprossesering p
        %%% disse slik at de er klare for beregning av trykkgradienten.
     
        function calculate(this)
            [height width] = size(this.img);
            for b = 1:length(this.high)
                info = zeros(1,10);
                left = [1 this.high(b) 1];
                right = left;
                
                structure = cell2mat(this.structs(b));
                if size(structure) < 2
                    continue;
                end
                for i = 1:length(structure(:,1))
                    if structure(i,1) ~= 1
                        if left(3) == 1
                            left(3) = i;
                        end
                        if right(3) == 1
                            right(3) = i;
                        end
                        this.img(structure(i,1), structure(i,2)) = 200;
                        if structure(i,2) < left(2)
                            left(1:2) = structure(i,:);
                            left(3) = i;
                        elseif structure(i,2) > right(2)
                            right(1:2) = structure(i,:);
                            right(3) = i;
                        end
                    end
                end
                
                for i = 1:length(structure(:,1))
                    if i < min(left(3),right(3))
                        this.img(structure(i,1), structure(i,2)) = 0;
                    elseif i > max(left(3), right(3))
                        this.img(structure(i,1), structure(i,2)) = 0;
                    end
                end
                
                data = [0 0];
                cnt = 1;

                for i = left(2):right(2)
                    for k = 1:height
                        if this.img(k,i) == 200
                            data(cnt,:) = [k i];
                            cnt = cnt + 1;
                            break;
                        end
                    end
                end
                   
                if length(data) < 3
                    return;
                end
                
                top = 0; low = 1000;
                for i = 1:length(data)-1
                    if data(i,1) < low
                        %Lowest point
                        low = data(i,1);
                    end
                    if data(i,1) > top
                        top = data(i,1);
                        %Highest point
                        info(1) = i;
                    end
                end
                
                middle = floor(low + 2*(top-low)/3);
                info(6) = middle;
                
                for i = 1:length(data)
                    %Midpoint of uprising curve
                    if info(5) == 0 && data(i,1) > middle
                        info(5) = i;
                    end
                end
                        
                %Kjr hastighetskurven inn i en metode som gjr
                %matematikken
                this.calculate2(data, info);
            end
            
        end
        
        %%%Forberede trace-kurven
        function [data data_out start endofrise] = prepareShape(this, varargin)
            warning('off', 'all');
            
            %Initialize variables, constants and arrays
            data = cell2mat(varargin(1));
            data_out = data(1:end,1);
            info = cell2mat(varargin(2)); 
            start = 1; start_spot = 1; 
            [height width] = size(this.img);
            end_of_rise = info(1); endofrise = end_of_rise;

            %Determine start of structure
            go = false; go2 = false;
            for i = info(5):-1:3
                if go == false && go2 == true; [null ms null null null] = this.dpdt(data(i,1));end;
                if go2 == false; [null ms null null null] = this.dpdt(data(i,1));end;
                if ms < 1.5
                    go2 = true;
                end
                if ms < 1
                    go = true;
                end
                if (((data(i,1)-data(i+1,1))  > 0 )||((data(i,1)-data(i+2,1)) == 0)) && go2 == true && start_spot == 1
                    start_spot = i;
                    break;
                end
            end
            
            
            [null frst null null null] = this.dpdt(data(1,1));
            [null lst null null null] = this.dpdt(data(end,1));

            %If structure is incomplete, end calculations
            if frst > 2 || lst > 2
                data_out = 0;return; 
            end
            
            %Find the end of up-rise curve
            first_edge1 = start_spot; first_edge2 = start_spot;
            
            if frst < 1.5
                %Determine if the beginning of the flow is cause by a valve
                %movement
                for i = start_spot:length(data(:,1))-22  
                    if (data(i+2,1) - data(i,1)) < 1 && first_edge1 == start_spot
                        first_edge1 = i;
                        first_edge2 = i;
                        for k = 1:20
                            if (data(i+k+2,1) - data(i+k,1)) > 1
                                first_edge2 = i+k;
                                break;
                            end
                        end
                    end
                end
                
                %Find the end of the rising segment of the flow
                if data(first_edge1,1) < info(6)
                    no = 1;
                    start = i;
                    for i = first_edge2:length(data(:,1))-2
                        if (no>3) || ((data(i+2,1)-data(i,1)) < -1)
                            end_of_rise = i-no-3;
                            break;
                        end
                        if (data(i,1)-data(i-1,1)) == 0 
                            no = no + 1;
                        else
                            no = 1;
                        end
                    end
                else
                    no = 1;
                 
                    for i = first_edge1:length(data(:,1))
                        if no > 5 || (data(i,1)-data(i-1,1)) < 0 
                            end_of_rise = i-no-3;
                            break;
                        end
                        if (data(i,1)-data(i-1,1)) == 0 
                            no = no + 1;
                        else
                            no = 1;
                        end
                   end
                 
                end
            end
            
            endpoint = length(data);endpoint2 =info(1); go = false;
                
            %Find the end of the structure
            for i = (length(data(:,1))-1):-1:1
                if go == false;[null ms null null null] = this.dpdt(data(i,1)); end;
                if ms > 1.5 && go == false
                    endpoint2 = i;
                    go = true;
                end
                    
                if go == true
                    for i = endpoint2:length(data(:,1))-4
                        if (data(i,1) < data(i+1,1)) || (data(i+4,1)-data(i,1) == 0)
                            endpoint = i;
                            break;
                        end
                    end
                end
                if endpoint ~= length(data)
                    break;
                end
            end
            
            %Find the middle point of the structure
            midpoint = start_spot+round((endpoint-start_spot)/2);
            
            %Find the start of down-rise
            for i = endpoint2:-1:midpoint
                if ((data(i-1,1)-data(i,1)) < 0) || ((data(i-5,1)-data(i,1)) == 0)
                    endpoint2 = i+5;
                    break;
                end
            end
            
           
            
            %Determine if flow structure needs model prediction
           need_prediction = false;
            lo = height; hi = [1 data_out(end_of_rise)]; ind = [midpoint data_out(midpoint)];
            for i = end_of_rise:endpoint2
               if diff([data_out(i+1) data_out(i)]) > 3 
                   need_prediction = true;
               end
               if data_out(i) < lo
                   lo = data_out(i);
               end      
               if data_out(i) > hi
                   hi = data_out(i);
                   ind = [i hi];
               end
            end
            
            if need_prediction == false
                if lo < min(data_out(end_of_rise), data_out(endpoint2))-4
                    need_prediction = true;
                end
            end
            
            m2 = round(midpoint+(endpoint-midpoint)*0.5);
            m1 = round(start_spot+((midpoint-start_spot)*0.5));
            disp('--------------');
            if need_prediction == true
                disp('Predicting');
                data_out((end_of_rise+1):(endpoint2-1)) = NaN;
                              
                if data_out(end_of_rise)>data_out(endpoint2)
                    disp('hei');
                    if end_of_rise > m1
                        disp('hei igjen');
                        data_out(midpoint) = data_out(end_of_rise)/(this.rel1 + 0.01*round(10*(((end_of_rise-m1)/(midpoint-m1)))));
%                         data_out(m2) = (this.rel1-0.02)*data_out(midpoint);
                    else
                        
                        temp = (m1-end_of_rise)*0.7;
                        data_out(midpoint) = temp+data_out(end_of_rise)/this.rel1;
                        data_out(m2) = (this.rel1-0.02)*data_out(midpoint);
                        data_out(m1) = this.rel1*data_out(midpoint);
                    end
                else
                    if endpoint2 < m2
                        data_out(midpoint) = data_out(endpoint2)/((this.rel1-0.02) + 0.01*round(10*(((m2-endpoint2)/(m2-midpoint)))));
%                         data_out(m1) = this.rel1*data_out(midpoint);
                    else
                        temp = (endpoint2-m2)*0.4;
                        data_out(midpoint) = (temp+data_out(endpoint2))/(this.rel1-0.02);
                        data_out(m2) = (this.rel1-0.02)*data_out(midpoint);
                        data_out(m1) = this.rel1*data_out(midpoint);
                    end
                end
                
                data_out(1:length(data_out)) = interp1(1:length(data_out), data_out(1:length(data_out)), 1:length(data_out), 'cubic');

            else
                disp('No prediction');
                data_out(end_of_rise:endpoint2) = smooth(data_out(end_of_rise:endpoint2), 60, 'moving');
                data_out = data_out-this.baseline;
                this.rel1 = (this.rel1*this.count + data_out(m1)/data_out(midpoint))/(this.count+1);
                this.rel2 = (this.rel2*this.count + data_out(m2)/data_out(midpoint))/(this.count+1);
                this.count = this.count + 1;
                data_out = data_out+this.baseline;

            end
            for i = start_spot:end_of_rise
                [null ms null null null] = this.dpdt(data_out(i));
                if ms >= 1 && this.onethree(1,1) < 1
                    this.onethree(1,1:2) = [data_out(i) data(i,2)];
                    break;
                end
             end
            
            if data(first_edge2,1) < 2*info(6)/3
%                 start = first_edge2;
                data_out(start_spot:first_edge2+3) = smooth(data_out(start_spot:first_edge2+3), 200, 'moving');
            else
                data_out(start_spot:info(6)) = smooth(data_out(start_spot:info(6)),10, 'moving');   
            end
            start = 1;
           
            
            data_out((end_of_rise-2):(endpoint2+5)) = smooth(data_out((end_of_rise-2):(endpoint2+5)),20, 'moving'); 
            
            for i = start_spot:endpoint
                if mod(i,5) ~= 1
                    data_out(i) = NaN;
                end
            end
            
            data_out(start_spot:endpoint) = interp1(start_spot:endpoint, data_out(start_spot:endpoint), start_spot:endpoint, 'spline');
            data_out(start_spot:(endpoint)) = smooth(data_out(start_spot:endpoint),30, 'moving');   


            data_out = data_out(start_spot:endpoint);
%             if this.calculate_tau == true
                data2 = data_out;
                temp = (data2(end-10)-data2(end-20))/10;
                temp2 = data2(end)-this.baseline;
                x = abs(round(temp2/temp))-6;
                data3 = zeros(1,(length(data2)+x+1));
                data3(2:(length(data2)+1)) = data2;
                data3(end) = round(this.baseline);
                data3(1) = round(this.baseline);
                data3((length(data2)-10):(end-1)) = NaN;
                data3 = interp1(1:length(data3), data3, 1:length(data3), 'cubic');
                data3((end-10):end) = smooth(data3((end-10):end), 160,'moving');
                data3(2:7) = NaN;
                data3 = interp1(1:length(data3), data3, 1:length(data3), 'cubic');

                data_out = data3;
%             end
            endofrise = end_of_rise- (start_spot-1);

            start = start - (start_spot-1);
            data = data(start_spot:end,2);
        end
        
        %%% Tar inn et datasett, dvs. en struktur/hastighetskurve. Kurven
        %%% smoothes og man kalkulerer trykkgradienten i hvert punkt, og
        %%% returnerer maksimal dP/dt. Finner samtidig trykkgradienten
        %%% mellom 1 og 3 m/s, slik det tradisjonelt har vrt gjort.
        
        %%%TO DO: Relaxation constant og glattere synkende kurve
        
        function calculate2(this, varargin)
            [data data_smoothed start endofrise] = this.prepareShape(cell2mat(varargin(1)), cell2mat(varargin(2)));
            if length(data_smoothed) < 50; return;end;
            
            
            %Variabler og konstanter
            done = false;  
            time = 1; maks = 0;
            xaxes = zeros(1,length(data_smoothed)); data_smoothed2 = data_smoothed;
            this.differentials = zeros(1,length(xaxes));
            
            rel_times = zeros(1,3); is_descending = false; ix2 = 1;
            % Regner ut trykkgradienten for hvert punkt p
            % hastighetskurven
            for i = 1:length(data_smoothed)-1
                [dpdt_tmp ms null dp time] = this.dpdt(data_smoothed(i+1), data_smoothed(i));  
                this.differentials(i) = int32(dpdt_tmp);
                if i > 1
                    %fiks denne denne dijwdkjshkjwhd
                    if (int32(dpdt_tmp) > maks) && (i > start)
                        if data_smoothed(i) >= data_smoothed(i-1)
                            maks = int32(dpdt_tmp); ix2 = i;
                        end
                    end
                end
                data_smoothed2(i) = dp;
                
                if ms >= 3 && this.onethree(2,1) < 1
                    this.onethree(2,1:2) = [data_smoothed(i) data(i)];
                    done = true;
                end
                
                if dpdt_tmp < 0 && is_descending == false && ms > 3
                    is_descending = true;
                end
                
                if is_descending == true
                    if ms < 3 && rel_times(3) == 0
                        rel_times(3) = time*i*1000;
                    elseif ms < 2 && rel_times(2) == 0
                        rel_times(2) = time*i*1000;
                    elseif ms < 1 && rel_times(1) == 0
                        rel_times(1) = time*1000*i;
                    end
                end
                
            end
            
            xaxes = time:time:((length(xaxes))*time);
            data_smoothed2(end) = data_smoothed2(end-1);
            xaxes = xaxes*1000;
                       
            if done == false
                % Blodhastigheten ble aldri s hy som 3 m/s.
                orig_dpdt = 0;
            else
                %Finner trykkgradienten mellom 1 og 3 m/s, slik som det
                %tradisjonelt gjres (RPR).
                [orig_dpdt null null null null] = this.dpdt(this.onethree(2,1), this.onethree(1,1), (this.onethree(2,2)-this.onethree(1,2)));
                this.original_dpdt(length(this.original_dpdt)+1) = int32(orig_dpdt);
            end
                       
            %Minimum og maksimum dP/dt    
            for i = 1:min(length(data_smoothed),length(data));
                data_smoothed(i) = round(data_smoothed(i));
                this.or_img(data_smoothed(i), round(data(i))) = this.clr;
            end
            this.dp_max(length(this.dp_max)+1) = max(data_smoothed2);
            [this.dpdt_min(length(this.dpdt_min)+1), ix] = min(this.differentials);
            this.dpdt_max(length(this.dpdt_max)+1) = maks;
             
            %Plot figures
            if this.show_plot == true
                a = length(this.dpdt_max-1);
                figure(a-1);
                subplot(2,1,1);
                plot(xaxes, data_smoothed2);
                ylabel('Pressure (mmHg)');
                xlabel('milliseconds from start of blood flow');
                grid('minor');
                subplot(2,1,2);
                plot(xaxes, this.differentials, 'r');
                ylabel('dP/dt (mmHg/s)');
                xlabel('milliseconds from start of blood flow');
                grid('minor');
            end  
            this.onethree = zeros(2,2);
            
            %Mark of max dP/dt
            for i = -3:3
                for k = -3:6:3
%                     if ix2 ~= 1;this.or_img(data_smoothed(ix2)+i,data(ix2)+k) = this.clr;end;
                end
            end
            for i = -3:3
                for k = -3:6:3
%                     if ix2~=1;this.or_img(data_smoothed(ix2)+k,data(ix2)+i) = this.clr;end;
                end
            end
            
            %Calculate relaxation constant
            if this.calculate_tau == true
                la = this.lap;
                
                %Method 1
                const = data_smoothed2(ix:end);
                a = length(this.dpdt_max-1);      
                const = const+la;
                const = log(const);
                x = 1:length(const);
                x = x.*(time*1000);
                p = polyfit(x,const,1);
                R=corrcoef(x,const);
                R(1,2);
                const = -(1/p(1));
                this.tau(length(this.tau)+1) = const;
                
                %Method 2
                const = 0;
                if rel_times(3) ~= 0
                    const = (rel_times(1)-rel_times(3))/(log(36+la)/log(4+la));
                end
                this.tau2(length(this.tau2)+1) = round(const);
            end
        end

        
        %%% Tar inn to koordinater og regner ut trykkgradienten mellom
        %%% disse to. 
        
        function [dpdt ms ms2 dp time] = dpdt(this, varargin)
            [height width] = size(this.img);
            if nargin>4
                height = cell2mat(varargin(4));
                width = cell2mat(varargin(5));
            end
            
            % Henter data for  beregne fart og tid i doppler-mlingene og
            % for  kombinere dette med spektraldataene.
            
            udth_cw = gcutil.udthandle(this.window,'CW');
            v = udth_cw.udtget('VNyquist'); 
            vspan = udth_cw.udtget('VSpan');
            time = gcutil.udthandle(this.window).udtget('HorizontalSweep');
            
            velocity = 2*v*vspan;
            baseln = udth_cw.udtget('Baseline'); 
            vel = velocity - (velocity*baseln); % Maks hastighet
            
            %Tilpasse 0-hastighetspunktet
            h = baseln*height;
            hh = height - h;
           
            t = 1;
            if length(varargin) > 2
                %Hvis to punkt er mer enn en horisontal enhet fra
                %hverandre, f.eks. ved 1-3 m/s mlinger
                t = abs(cell2mat(varargin(3)));
            end
            
            time = time/width; % Angir hvor lang tid(sekund) en pixel tilsvarer.
            t = t*time;
            
            %De vertikale koordinatene til de to punktene. Justeres i
            %forhold til 0-hastighetspunktet.
            vel1 = vel*(cell2mat(varargin(1))-h)/hh;
            
            if nargin == 2
                dpdt = 0; ms2 = 0;
                ms = vel1; dp = 1;
                return;
            end
            
            vel2 = vel*(cell2mat(varargin(2))-h)/hh;
            v1 = 4*(vel2^2);    
            dp = v1;
            
            v2 = 4*(vel1^2);
            
            dpdt = (v2 - v1)/t; % Bernoulli's prinsipp
            
            ms = vel2;
            ms2 = vel1;
                
        end
            
        %%%For funksjonen for  trace manuelt.
        function manual_tracing(this, varargin)
            coords = [1 1; 1 1];
            points = this.coor;
            this.window.udth('Ecg').gcset('Visible',0);
            out = getframe(this.fig);
            vp = this.window.viewer.viewport;
            in = out.cdata(vp(4)+1-(vp(4):-1:1),vp(1)+(1:vp(3)),:);
            
            [height width depth] = size(in);
            
            top = 0;
            for k = 1:width
                no = 0; 
                for i = 3:floor(0.75*height)
                    if in(i,k) ~= 0
                        no = no + 1;
                        if top == 0
                            top = i;
                        end
                    end
                    
                end
                if no > 1
                    coords(1,2) = k;
                    break;
                end
            end
            
            while 1 == 1
                no = 0;
                for k = 1:floor(width/2)
                    if in(top, k) ~= 0
                        no = no + 1;
                    end
                end
                if no ~= 0
                    top = top - 1;
                else
                    coords(1,1) = top+1;
                    break;
                end
            end
            
            top = floor(0.75*height);
            while 1 == 1
                no = 0;
                for k = 1:floor(3*width/4)
                    if in(top, k) ~= 0
                        no = no + 1;
                    end
                end
                if no ~= 0
                    top = top + 1;
                else
                    coords(2,1) = top-2;
                    break;
                end
            end
            side = floor(0.75*width);
                
            p = 1;
            while p == 1
                for i = coords(1,1):height
                    a = [in(i,side,1) in(i,side,2) in(i,side,3)];
                    if a == [0 255 0]
                        coords(2,2) = side-2;
                        p = 0;
                        break;
                    end
                end
                side = side + 1;
                if side > width
                    break;
                end
            end
            
            in((points(1,1)-2):2:(points(1,1)+2), (points(1,2)-2):2:(points(1,2)+2), 1:3) = 255;
            in((points(2,1)-2):2:(points(2,1)+2), (points(2,2)-2):2:(points(2,2)+2), 1:3) = 255;

            h = coords(2,1) - coords(1,1);
            w = coords(2,2) - coords(1,2);
            
            [dpdt m1 m2] = this.dpdt(points(2,1)-coords(1,1), points(1,1)-coords(1,1), (points(2,2)-points(1,2)), h, w);
            
                
            this.window.viewer.info(strcat(num2str(int32(dpdt)), ' mmHg/s'), 7);
            this.window.viewer.info(strcat(num2str(m1), ' m/s'), 8);
            this.window.viewer.info(strcat(num2str(m2), ' m/s'), 9);

            hnd1=text(263,168,'Name');
            set(hnd1,'FontSize',36)
            if this.show == true, title(num2str(dpdt));imtool(in); end
        end
            
        
        % ------------------------------------------------------------------
        % Mouse handler stuff.
        % TODO: Remove this line if you dont need to handle any mouse events.
        % Yous should remove the events that you do not need
            
        function on_mouse_callback_completed(this,evt)
            w = this.window;
            w.toolbox('cine').get_mouse_handler.cb(evt)
        end
        
        function out = create_context_menu(this,x,y)
            % TODO: (*) To modify default context menu, do either:
            
            % i) disable context menu
            % out = []
            
            % ii) add stuff to context menu            
            out = uicontextmenu;    
            set(out,'DeleteFcn',@this.delete_context_menu)
            uimenu(out,'Label','Donate to GcLab foundation today!','Callback',@(varargin)disp('Just kidding'))
            uimenu(out,'Label',['Reset "',this.menutext,'" tool'],'Callback',@(varargin)this.reset);
        end
        
        function out=on_mouse_move(this)
            % TODO: (*) Either do something useful here, or delete the function
            % gcutil.info('Example toolbox mouse action: pos=',[this.evt.x this.evt.y])
            out=true; 
        end
        
        % TODO: (*) Implement any of these if you wish (and remember to reset out=true)
        function out=on_left_down(this)
            pos = [this.evt.y this.evt.x]; 

            if this.coor(1,1) == 0
                this.coor(1,1:2) = pos;
            elseif this.coor(2,1) == 0
                if this.coor(1,1) ~= 0
                    this.coor(2,1:2) = pos;
                end
            elseif ~((this.coor(1,1) == 0) || (this.coor(2,1) == 0))
                this.coor(1,1:2) = pos;
                this.coor(2,1:2) = 0;
            end

            disp(pos);
            out=false;
        
        end
        %function out=on_left_up(this), out=false; end
        %function out=on_double_click(this), out=false; end
        %function out=on_right_down(this), out=false; end
        %function out=on_right_up(this), out=false; end
        %function out=on_wheel(this), out=false; end
        %function out=on_dragging(this), out=false; end
        %function out=on_dragging_finished(this), out=false; end
        %function out=on_key_pressed(this), out=false; end
        
    end % methods
    
end